#include<stdio.h>
#include<conio.h>
#include<string.h>
#include<time.h>
#include "..\lib\9188d.h"

/*
 Use 9188 COM2 link to 9052/53 (8/16 D/I) x 2.
 address 01 : 9053-1, connect to COM2(RS485) of 9188
	      9600,N,8,1
 address 02 : 9053-2, connect to COM2(RS485) of 9188
	      9600,N,8,1
 9188 COM4 link to PC COM port

 5digitled  : digit 1 will show channel no.
	      digit 2-5 will show the DIO value
*/

unsigned CheckTime;

char h_to_a[16] ={
 '0','1','2','3','4','5','6','7',
 '8','9','A','B','C','D','E','F'
};

char *Binary[16]=
{
  "0000",
  "0001",
  "0010",
  "0011",
  "0100",
  "0101",
  "0110",
  "0111",
  "1000",
  "1001",
  "1010",
  "1011",
  "1100",
  "1101",
  "1110",
  "1111",
};

int ascii_to_hex(char c){
 if(c<='9')
	return(c-'0');
 else
	return(c-'A'+10);
}
/*-----------------------------------------------------*/
/* This function sends commands and receive result from 9000 module */
/* It also shows the DIO status on 5-digit LED */
/* It also shows the result to the PC console */
int read_9000(unsigned char *cmd)
{  unsigned char str[20];
   int val,data;
   static unsigned long count=0;

   count++;
   SendCmdTo9000(2,cmd, 0);
   printf("\n[%lu]Send=%s, Receive=",count,cmd);
   val=ReceiveResponseFrom9000(2,str, 60000L, 0);
   if (val==NoError) {
      printf("%s ",str);
      /* show the I/O value */
      data=ascii_to_hex(str[1]);
      Show5DigitLed(2,data);
      printf("[%s",Binary[data]);
      data=ascii_to_hex(str[2]);
      Show5DigitLed(3,data);
      printf(" %s",Binary[data]);
      data=ascii_to_hex(str[3]);
      Show5DigitLed(4,data);
      printf(" %s",Binary[data]);
      data=ascii_to_hex(str[4]);
      Show5DigitLed(5,data);
      printf(" %s]",Binary[data]);
   }
   else printf("Errorno=%d(%s)",val,val==TimeOut?"TimeOut":"");
   return val;
}

/* ------------------------------------------------------------------- */
char OutCmd[10]="@01";
void  main()
{ int i,k;
  unsigned char c,cmd[80];
  int ledmode=1;
  int quit=0;
  clock_t start,end,start2;

  InstallCom(2,9600L,8,0,1);	/* COM2, RS-485, half-duplex mode, INT	     */
				/*	 --> need to control 485 direction   */
				/*	 --> initial 485 direction = Receive */

  /* COM4, RS-232, connect to PC's COM port for download   */
  Init5DigitLed();		/* initial & blank the 5-digit LED  */
  LedOn();			/* red-LED on			    */
  start=clock();
  Show5DigitLed(1,1);
  read_9000("$01M");        /* read module name of address 1 */
			      /* 7053 will echo !017053 */
  read_9000("$02M");        /* read module name of address 2 */
			      /* 7053 will echo !027053 */
  printf("\n'1': show channel 1"
	 "\n'2': show channel 2"
	 "\n'q'  : quit"
	 "\npress any key to start.");
  for (;!quit;) {
    end=clock();
    //blink the led
    if((end-start)/CLK_TCK >= 0.5){
       ledmode=!ledmode;  if (ledmode) LedOn(); else LedOff();
       start=clock();
    }
    if (kbhit()) {		/* is user press PC's keyboard from COM4   */
       c=getch();		/* if this key is Q or Q --> exit this program */
       if ((c=='q') || (c=='Q')) quit=1;
       else {
	  if(c=='1'){
	     OutCmd[2]='1';    /* switch to channel 1 --> @01 */
	     //first digit is the channel number
	     Show5DigitLed(1,1);
	     Show5DigitLed(2,16);
	     Show5DigitLed(3,16);
	     Show5DigitLed(4,16);
	     Show5DigitLed(5,16);
	  }
	  else if(c=='2'){
		  OutCmd[2]='2';  /* switch to channel 2 --> @02 */
		  //first digit is the channel number
		  Show5DigitLed(1,2);
		  Show5DigitLed(2,16);
		  Show5DigitLed(3,16);
		  Show5DigitLed(4,16);
		  Show5DigitLed(5,16);
	  }
       }
    }
    else {
	//get the DIO status and show them on 5-dig LED
	read_9000(OutCmd);
    }
  }
  RestoreCom(2);
  return;
}

/* ------------------------------------------------------------------- */


